Subject: [rohc] RFC 3095 "O-mode Optional feedback"

From: "Couch, William Garrant, JR (Garry)" <[email-masked]>
Date: Mon, 6 Jun 2005 10:24:27 -0400

All,

An issue of interpretation has arisen with respect to section 5.4.2.2 of RFC 3095 (below).  Briefly, what is meant by the term optional feedback in O-mode?  Is it the case that all feedback is optional or is the optional feedback indicated as such in the text and applies to sending an ACK(O) for correct decompression of a type 2 or IR-DYN packet when the decompressor is in the SC or FC state?

Garry Couch
System Engineer
CDMA Radio Access Networks
Whippany, NJ
973 386-7437

*************************************************************************************
5.4.2.2.  Feedback logic (O-mode)

   The feedback logic defines what feedback to send due to different
   events when operating in the various states.  As mentioned above,
   there are three principal kinds of feedback; ACK, NACK and STATIC-
   NACK.  Further, the logic described below will refer to different
   kinds of packets that can be received by the decompressor;
   Initialization and Refresh (IR) packets, IR packets without static
   information (IR-DYN) and type 2 packets (UOR-2), or type 1 (UO-1) and
   type 0 packets (UO-0).  A type 0 packet carries a packet header
   compressed according to a fixed pattern, while type 1, 2 and IR-DYN
   packets are used when this pattern is broken.

   Below, rules are defined stating which feedback to use when.  If the
   optional feedback is used once, the decompressor is REQUIRED to
   continue to send optional feedback for the lifetime of the packet
   stream.

   State Actions

   NC:  - When an IR packet passes the CRC check, send an ACK(O).
        - When receiving a type 0, 1, 2 or IR-DYN packet, or an IR
          packet has failed the CRC check, send a STATIC-NACK(O),
          subject to the considerations at the beginning of section
          5.7.6.

   SC:  - When an IR packet is correctly decompressed, send an ACK(O).
        - When a type 2 or an IR-DYN packet is correctly decompressed,
          optionally send an ACK(O).
        - When a type 0 or 1 packet is received, treat it as a
          mismatching CRC and use the logic of section 5.3.2.2.3 to
          decide if a NACK(O) should be sent.
        - When decompression of a type 2 packet, an IR-DYN packet or an
          IR packet has failed, use the logic of section 5.3.2.2.3 to
          decide if a STATIC-NACK(O) should be sent.

   FC:  - When an IR packet is correctly decompressed, send an ACK(O).
        - When a type 2 or an IR-DYN packet is correctly decompressed,
          optionally send an ACK(O).
        - When a type 0 or 1 packet is correctly decompressed, no
          feedback is sent.
        - When any packet fails the CRC check, use the logic of
          5.3.2.2.3 to decide if a NACK(O) should be sent.

_______________________________________________
Rohc mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/rohc

---

From: "Lars-Erik Jonsson (LU/EAB)" <[email-masked]>
Date: Tue, 7 Jun 2005 08:47:32 +0200

Garry,

The latter interpretation is the only possible alternative, as O-mode
relies on negative feedback in case of failure (this is how O-mode
differs from U-mode). This interpretation is also the only one I can
reasonably make from the text of 5.4.2.2.

BR
/L-E

> -----Original Message-----
> From: [email-masked] [mailto:[email-masked]]On Behalf Of
> Couch, William Garrant, JR (Garry)
> Sent: den 6 juni 2005 16:24
> To: [email-masked]'
> Subject: [rohc] RFC 3095 "O-mode Optional feedback"
> 
> 
> All,
> 
> An issue of interpretation has arisen with respect to section 
> 5.4.2.2 of RFC 3095 (below).  Briefly, what is meant by the 
> term optional feedback in O-mode?  Is it the case that all 
> feedback is optional or is the optional feedback indicated as 
> such in the text and applies to sending an ACK(O) for correct 
> decompression of a type 2 or IR-DYN packet when the 
> decompressor is in the SC or FC state?
> 
> 
> Garry Couch
> System Engineer

---

From: "Couch, William Garrant, JR (Garry)" <[email-masked]>
Date: Tue, 7 Jun 2005 12:36:29 -0400

Lars,

Thanks, this is what made sense to me as well.

Garry

-----Original Message-----
From: Lars-Erik Jonsson (LU/EAB) [mailto:[email-masked]]
Sent: Tuesday, June 07, 2005 2:48 AM
To: Couch, William Garrant, JR (Garry); [email-masked]
Subject: RE: [rohc] RFC 3095 "O-mode Optional feedback"

Garry,

BR
/L-E

---

From: "Couch, William Garrant, JR (Garry)" <[email-masked]>
Date: Wed, 8 Jun 2005 11:14:35 -0400

Lars,

However, isn't it true that O-mode compressor relies on positive feedback [ACK(O)] from the decompressor to move out of the IR state.

Garry

-----Original Message-----
From: Lars-Erik Jonsson (LU/EAB) [mailto:[email-masked]]
Sent: Tuesday, June 07, 2005 2:48 AM
To: Couch, William Garrant, JR (Garry); [email-masked]
Subject: RE: [rohc] RFC 3095 "O-mode Optional feedback"

Garry,

BR
/L-E

---

From: "Kristofer Sandlund (LU/EAB)" <[email-masked]>
Date: Wed, 8 Jun 2005 17:19:39 +0200

Hi Garry,

the compressor does not rely on ACKs to leave IR state, it can use the optimistic approach to decide this. 

You should note that the state concept on the compressor side is not normative, it was just used as a way to help implementations. A compressor can choose to send IR packets even in the case where it is enough to send "small" packets.

/Kristofer

>Sent: Wednesday, June 08, 2005 5:15 PM
>To: Lars-Erik Jonsson (LU/EAB); [email-masked]
>However, isn't it true that O-mode compressor relies on 
>positive feedback [ACK(O)] from the decompressor to move out 
>of the IR state.
>
>Garry
>